
# TC ID Checker for Dart & Flutter

Checks that Turkish ID number is valid or not.

## Features

* Determines that given TC Id is valid or not based on rules typed below.

## How to Work

* The ones digit of the sum of the first 10 digits gives the 11th digit.

* The ones digit of 7 times the sum of the 1st, 3rd, 5th, 7th and 9th digits plus 9 times the sum of the 2nd, 4th, 6th and 8th digits gives the 10th digit.

* The ones digit of 8 times the sum of the 1st, 3rd, 5th, 7th and 9th digits gives the 11th digit. 

## Usage
 
1. Add this to your package's pubspec.yaml file:

```dart
tcid_checker: ^1.0.0
```

2. Save the pubspec.yaml file. Or alternatively you can use this code snippet on console:

```dart
pub get
```

with Flutter:

```dart
flutter pub get
```

3. Import it from code file:

```dart
import 'package:tcid_checker/tcid_checker.dart';
```

## License

* This project is licensed under the MIT License.


## Additional information

#### [Author: berkbb](https://github.com/berkbb) 

#### [pub.dev]() 

#### [GitHub Page](https://github.com/berkbb/tcid_checker) 


